#!/usr/bin/env python

import gtk

class dc7i76:
  def __init__(self):
    self.builder = gtk.Builder()
    self.builder.add_from_file('lib/dc7i76.glade')
    self.builder.connect_signals(self)

    self.mode = {}
    for i in range(4):self.mode['mode_'+str(i)]=self.builder.get_object('mode_'+str(i))
    self.mode_selected = {'mode':'mode_0'}

    # setup stepgen combobox
    self.stepgen_list = gtk.ListStore(int, str)
    self.stepgen_list.append([0, 'None'])
    self.stepgen_list.append([1, 'X Axis'])
    self.stepgen_list.append([2, 'Y Axis'])
    self.stepgen_list.append([3, 'Z Axis'])
    self.stepgen_list.append([4, 'A Axis'])
    self.stepgen_list.append([5, 'B Axis'])
    self.stepgen_list.append([6, 'C Axis'])
    self.stepgen_list.append([7, 'U Axis'])
    self.stepgen_list.append([8, 'V Axis'])
    self.stepgen_list.append([9, 'W Axis'])

    self.cell = gtk.CellRendererText()

    self.stepgens = {}
    for i in range(5):self.stepgens['stepgen_'+str(i)]=self.builder.get_object('stepgen_'+str(i))

    for i in range(5):
      self.stepgens.get('stepgen_'+str(i)).set_model(self.stepgen_list)
      self.stepgens.get('stepgen_'+str(i)).pack_start(self.cell, True)
      self.stepgens.get('stepgen_'+str(i)).add_attribute(self.cell, 'text', 1)
      self.stepgens.get('stepgen_'+str(i)).set_active(0)

    self.stepgen_select = {}
    for i in range(5):self.stepgen_select['stepgen_'+str(i)] = '0'

    self.step_inverts = {}
    for i in range(5):self.step_inverts['step_invert_'+str(i)]=self.builder.get_object('step_invert_'+str(i))

    self.step_invert_select = {}
    for i in range(5):self.step_invert_select['step_invert'+str(i)] = False

    self.dir_inverts = {}
    for i in range(5):
      self.dir_inverts['dir_invert_'+str(i)]=self.builder.get_object('dir_invert_'+str(i))

    self.dir_invert_select = {}
    for i in range(5):self.dir_invert_select['dir_invert'+str(i)] = False

    # setup output combobox
    self.output_list = gtk.ListStore(int, str)
    self.output_list.append([0, 'None'])
    self.output_list.append([1, 'Coolant Flood'])
    self.output_list.append([2, 'Coolant Mist'])
    self.output_list.append([3, 'Digital Out 0'])
    self.output_list.append([4, 'Digital Out 1'])
    self.output_list.append([5, 'Digital Out 2'])
    self.output_list.append([6, 'Digital Out 3'])
    self.output_list.append([7, 'Digital Out 4'])

    self.outputs = {}
    for i in range(16):self.outputs['output_'+str(i)]=self.builder.get_object('output_'+str(i))

    self.output_select ={}
    for i in range(16):self.output_select['output_'+str(i)] = '0'

    for i in range(16):
      self.outputs.get('output_'+str(i)).set_model(self.output_list)
      self.outputs.get('output_'+str(i)).pack_start(self.cell, True)
      self.outputs.get('output_'+str(i)).add_attribute(self.cell, 'text', 1)
      self.outputs.get('output_'+str(i)).set_active(0)

    # setup input comboboxes
    self.input_type_list = gtk.ListStore(int, str)
    self.input_type_list.append([0, 'None'])
    self.input_type_list.append([1, 'Limit'])
    self.input_type_list.append([2, 'Home'])
    self.input_type_list.append([3, 'Home & Limit'])
    self.input_type_list.append([4, 'Misc'])

    self.input_types = {}
    for i in range(48):
      self.input_types['input_type_'+str(i)] = self.builder.get_object('input_type_'+str(i))

    for i in range(48):
      self.input_types.get('input_type_'+str(i)).set_model(self.input_type_list)
      self.input_types.get('input_type_'+str(i)).pack_start(self.cell, True)
      self.input_types.get('input_type_'+str(i)).add_attribute(self.cell, 'text', 1)
      self.input_types.get('input_type_'+str(i)).set_active(0)

    self.input_type = {}
    for i in range(48):
      self.input_type['input_type_'+str(i)] = '0'

    self.inputs = {}
    for i in range(48):
      self.inputs['input_setting_'+str(i)] = self.builder.get_object('input_setting_'+str(i))

    self.input_setting = {}
    for i in range(48):
      self.input_setting['input_setting_'+str(i)] = '0'

    self.input_limit = gtk.ListStore(int, str)
    self.input_limit.append([0, 'None'])
    self.input_limit.append([1, 'X Axis Both'])
    self.input_limit.append([2, 'Y Axis Both'])
    self.input_limit.append([3, 'Z Axis Both'])
    self.input_limit.append([4, 'X Axis Positive'])
    self.input_limit.append([5, 'X Axis Negative'])
    self.input_limit.append([6, 'Y Axis Positive'])
    self.input_limit.append([7, 'Y Axis Negative'])
    self.input_limit.append([8, 'Z Axis Positive'])
    self.input_limit.append([9, 'Z Axis Negative'])

    self.input_home = gtk.ListStore(int, str)
    self.input_home.append([0, 'None'])
    self.input_home.append([1, 'X Axis Positive'])
    self.input_home.append([2, 'X Axis Negative'])
    self.input_home.append([3, 'Y Axis Positive'])
    self.input_home.append([4, 'Y Axis Negative'])
    self.input_home.append([5, 'Z Axis Positive'])
    self.input_home.append([6, 'Z Axis Negative'])

    self.input_home_limit = gtk.ListStore(int, str)
    self.input_home_limit.append([0, 'None'])
    self.input_home_limit.append([1, 'X Axis Both'])
    self.input_home_limit.append([2, 'Y Axis Both'])
    self.input_home_limit.append([3, 'Z Axis Both'])
    self.input_home_limit.append([4, 'X Axis Positive'])
    self.input_home_limit.append([5, 'X Axis Negative'])
    self.input_home_limit.append([6, 'Y Axis Positive'])
    self.input_home_limit.append([7, 'Y Axis Negative'])
    self.input_home_limit.append([8, 'Z Axis Positive'])
    self.input_home_limit.append([9, 'Z Axis Negative'])

    self.input_misc = gtk.ListStore(int, str)
    self.input_misc.append([0, 'None'])
    self.input_misc.append([1, 'E-Stop In'])
    self.input_misc.append([2, 'Probe In'])
    self.input_misc.append([3, 'Digital In 0'])
    self.input_misc.append([4, 'Digital In 1'])
    self.input_misc.append([5, 'Digital In 2'])
    self.input_misc.append([6, 'Digital In 3'])
    self.input_misc.append([7, 'Digital In 4'])

    self.spindle = {}
    for i in range(4):self.spindle['spindle_'+str(i)]=self.builder.get_object('spindle_'+str(i))
    self.spindle_selected = {'spindle_selected':'spindle_0'}


  # update dicts
  def on_mode_toggled(self, widget):
    if widget.get_active():
      self.mode_selected['mode'] = gtk.Buildable.get_name(widget)

  def on_stepgen_changed(self, widget):
    if widget.get_active():
      self.index = widget.get_active()
      self.model = widget.get_model()
      # store the index of the selected axis
      self.stepgen_select[gtk.Buildable.get_name(widget)] = str(self.model[self.index][0])

  def on_output_changed(self, widget):
    if widget.get_active():
      self.model = widget.get_model()
      self.index = widget.get_active()
      self.output_select[gtk.Buildable.get_name(widget)] = str(self.model[self.index][0])

  def on_input_type_changed(self, widget):
    if widget.get_active():
      self.model = widget.get_model()
      self.index = widget.get_active()
      self.number = gtk.Buildable.get_name(widget).split('_')[2]
      self.inputs.get('input_setting_'+self.number).clear()
      if self.model[self.index][0] == 1:
        self.inputs.get('input_setting_'+self.number).set_model(self.input_limit)
      if self.model[self.index][0] == 2:
        self.inputs.get('input_setting_'+self.number).set_model(self.input_home)
      if self.model[self.index][0] == 3:
        self.inputs.get('input_setting_'+self.number).set_model(self.input_home_limit)
      if self.model[self.index][0] == 4:
        self.input_setting.get('input_setting_'+self.number).set_model(self.input_misc)
      self.inputs.get('input_setting_'+self.number).pack_start(self.cell, True)
      self.inputs.get('input_setting_'+self.number).add_attribute(self.cell, 'text', 1)
      self.inputs.get('input_setting_'+self.number).set_active(0)
      self.input_type[gtk.Buildable.get_name(widget)] = str(self.model[self.index][0])

  def on_input_setting_changed(self, widget, data=None):
    if widget.get_active():
      self.model = widget.get_model()
      self.index = widget.get_active()
      self.input_setting[gtk.Buildable.get_name(widget)] = str(self.model[self.index][0])

  def on_spindle_toggled(self, widget):
    if widget.get_active():
      self.spindle_selected['spindle_selected'] = gtk.Buildable.get_name(widget)

  def settings(self):
    self.dc7i76 = {}
    self.dc7i76.update(self.mode_selected)
    self.dc7i76.update(self.stepgen_select)
    for i in range(5):
      self.step_invert_select['step_invert_'+str(i)] = str(self.step_inverts['step_invert_'+str(i)].get_active())
    self.dc7i76.update(self.step_invert_select)
    for i in range(5):
      self.dir_invert_select['dir_invert_'+str(i)] = str(self.dir_inverts['dir_invert_'+str(i)].get_active())
    self.dc7i76.update(self.dir_invert_select)
    self.dc7i76.update(self.output_select)
    self.dc7i76.update(self.input_type)
    self.dc7i76.update(self.input_setting)
    self.dc7i76.update(self.spindle_selected)

    return self.dc7i76
