#!/usr/bin/env python

import gtk

class dc7i78:
  def __init__(self):
    self.builder = gtk.Builder()
    self.builder.add_from_file('lib/dc7i78.glade')
    self.builder.connect_signals(self)

    # setup stepgen combobox
    self.stepgen_list = gtk.ListStore(int, str)
    self.stepgen_list.append([0, 'None'])
    self.stepgen_list.append([1, 'X Axis'])
    self.stepgen_list.append([2, 'Y Axis'])
    self.stepgen_list.append([3, 'Z Axis'])
    self.stepgen_list.append([4, 'A Axis'])

    self.cell = gtk.CellRendererText()

    self.stepgens = {}
    for i in range(5):self.stepgens['stepgen_'+str(i)]=self.builder.get_object('stepgen_'+str(i))

    for i in range(5):
      self.stepgens.get('stepgen_'+str(i)).set_model(self.stepgen_list)
      self.stepgens.get('stepgen_'+str(i)).pack_start(self.cell, True)
      self.stepgens.get('stepgen_'+str(i)).add_attribute(self.cell, 'text', 1)
      self.stepgens.get('stepgen_'+str(i)).set_active(0)

    self.stepgen_select = {}
    for i in range(5):self.stepgen_select['stepgen_'+str(i)] = '0'

    self.step_inverts = {}
    for i in range(5):self.step_inverts['step_invert_'+str(i)]=self.builder.get_object('step_invert_'+str(i))

    self.step_invert_select = {}
    for i in range(5):self.step_invert_select['step_invert'+str(i)] = False

    self.dir_inverts = {}
    for i in range(5):
      self.dir_inverts['dir_invert_'+str(i)]=self.builder.get_object('dir_invert_'+str(i))

    self.dir_invert_select = {}
    for i in range(5):self.dir_invert_select['dir_invert'+str(i)] = False

  def on_stepgen_changed(self, widget):
    if widget.get_active():
      self.index = widget.get_active()
      self.model = widget.get_model()
      # store the index of the selected axis
      self.stepgen_select[gtk.Buildable.get_name(widget)] = str(self.model[self.index][0])

  def settings(self):
    self.dc7i78 = {}
    self.dc7i78.update(self.stepgen_select)
    for i in range(5):
      self.step_invert_select['step_invert_'+str(i)] = str(self.step_inverts['step_invert_'+str(i)].get_active())
    self.dc7i78.update(self.step_invert_select)
    for i in range(5):
      self.dir_invert_select['dir_invert_'+str(i)] = str(self.dir_inverts['dir_invert_'+str(i)].get_active())
    self.dc7i78.update(self.dir_invert_select)

    return self.dc7i78
